%define	name	mpich2
%define	version 1.0.4
%define subversion p1
%define release	%mkrel 7

%define	major		1.0.4
%define	libname		%mklibname mpich 2 %{major}
%define old_libname	%mklibname mpich 1
%define mpihome		/home/mpi

Name: 		%{name}
Version: 	%{version}
Release: 	%{release}
Summary: 	MPICH2 is a portable implementation of MPI
Source: 	http://www-unix.mcs.anl.gov/mpi/mpich/downloads/%{name}-%{version}%{subversion}.tar.bz2
Patch0:		%{name}-1.0.4.soname.patch
URL: 		http://www-unix.mcs.anl.gov/mpi/mpich/
License:	BSD-style 
Group: 		Development/Other
Requires: 	%{libname} = %{version}
Requires:	expect
Requires:	python
BuildRequires:	gcc-gfortran
BuildRequires:	python
BuildConflicts:	g95
Conflicts:	mpich >= 1.2
BuildRoot: 	%{_tmppath}/%{name}-%{version}

%description
MPICH is a freely available, portable implementation of MPI, the Standard 
for message-passing libraries.
MPICH-A Portable Implementation of MPI is a MPI Standard conforming library 
that was developed by the Argonne National Laboratory. It allows different 
processes across a network of workstations to communicate using specific 
message passing functions. It includes librairies, parallel debuging tools 
and docs.

This package provides the libraries that use the standard p4 device.

%package doc
Summary:	Documentation for developing programs that will use MPICH
Group:		Development/Other

%description doc
MPICH is a freely available, portable implementation of MPI, the Standard 
for message-passing libraries.
MPICH-A Portable Implementation of MPI is a MPI Standard conforming library 
that was developed by the Argonne National Laboratory. It allows different 
processes across a network of workstations to communicate using specific 
message passing functions. It includes librairies, parallel debuging tools 
and docs.

This package provides the documentation needed to develop
applications using the MPICH libraries.

%package -n %{libname}
Summary:	Shared Librairies for MPICH
Group:		Development/Other
Conflicts:	%{old_libname} >= 1.2
Provides:	lib%{name} = %{version}-%{release}
Conflicts:	libmpich

%description  -n %{libname}
Shared Librairies for MPICH

%package -n %{libname}-devel
Summary:	Headers for developing programs that will use MPICH
Group:		Development/Other
Requires:	%{libname} = %{version}
Conflicts:	%{old_libname}-devel >= 1.2
Provides:	lib%{name}-devel = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}
Conflicts:	lam-devel, mpich1-devel

%description -n %{libname}-devel
MPICH is a freely available, portable implementation of MPI, the Standard 
for message-passing libraries.
MPICH-A Portable Implementation of MPI is a MPI Standard conforming library 
that was developed by the Argonne National Laboratory. It allows different 
processes across a network of workstations to communicate using specific 
message passing functions. It includes librairies, parallel debuging tools 
and docs.

This package provides the static libraries and header files needed to compile
applications using the MPICH libraries.

%package -n mpi2cc
Summary:	The MPICH wrapper over the C compiler
Group:		Development/C
Conflicts:	mpicc >= 1.2, lam-devel
Requires:	gcc >= 3.2
Requires:	%{libname}-devel = %{version}

%description -n mpi2cc
MPICH is a freely available, portable implementation of MPI, the Standard 
for message-passing libraries.
MPICH-A Portable Implementation of MPI is a MPI Standard conforming library 
that was developed by the Argonne National Laboratory. It allows different 
processes across a network of workstations to communicate using specific 
message passing functions. It includes librairies, parallel debuging tools 
and docs.

This package provides the shell script mpicc, with headers, which allows to
compile C programs using the MPICH libraries.

%package -n mpi2cxx
Summary:	The MPICH wrapper over the C++ compiler
Conflicts:	mpic++ >= 1.2, lam-devel
Group:		Development/C++
Requires:	gcc-c++ >= 3.2
Requires:	%{libname}-devel = %{version}

%description -n mpi2cxx
MPICH is a freely available, portable implementation of MPI, the Standard 
for message-passing libraries.
MPICH-A Portable Implementation of MPI is a MPI Standard conforming library 
that was developed by the Argonne National Laboratory. It allows different 
processes across a network of workstations to communicate using specific 
message passing functions. It includes librairies, parallel debuging tools 
and docs.

This package provides the shell script mpiCC, with headers, which allows to
compile C++ programs using the MPICH libraries.

%package -n mpi2f77
Summary:	The MPICH wrapper over the Fortran 77 compiler
Group:		Development/Other
Conflicts:	mpif77 >= 1.2, lam-devel
Requires:	gcc-gfortran >= 3.2
Requires:	%{libname}-devel = %{version}

%description -n mpi2f77
MPICH is a freely available, portable implementation of MPI, the Standard 
for message-passing libraries.
MPICH-A Portable Implementation of MPI is a MPI Standard conforming library 
that was developed by the Argonne National Laboratory. It allows different 
processes across a network of workstations to communicate using specific 
message passing functions. It includes librairies, parallel debuging tools 
and docs.

This package provides the shell script mpif77, with headers, which allows to
compile Fortran 77 (NOT Fortran 90!) programs using the MPICH libraries.

%package -n mpi2f90
Summary:	The MPICH wrapper over the Fortran 90 compiler
Group:		Development/Other
Requires:	gcc-gfortran >= 3.2
Requires:	%{libname}-devel = %{version}

%description -n mpi2f90
MPICH is a freely available, portable implementation of MPI, the Standard 
for message-passing libraries.
MPICH-A Portable Implementation of MPI is a MPI Standard conforming library 
that was developed by the Argonne National Laboratory. It allows different 
processes across a network of workstations to communicate using specific 
message passing functions. It includes librairies, parallel debuging tools 
and docs.

This package provides the shell script mpif90, with headers, which allows to
compile Fortran 90 (NOT Fortran 77!) programs using the MPICH libraries.

%prep
%setup -q -n %{name}-%{version}%{subversion}
%patch0 -p 1

%build
export F90=/usr/bin/gfortran

%configure \
    --datadir=%{_datadir}/mpich/ \
    --with-docdir=%{_datadir}/doc/%{name}-doc-%{version} \
    --with-htmldir=%{_datadir}/doc/%{name}-doc-%{version}/www \
    --enable-cache \
    --with-mpe \
    --enable-cxx \
    --with-arch=LINUX \
    --enable-sharedlibs=gcc \
    --disable-weak-symbols
make

%install
rm -rf %{buildroot}

%makeinstall_std

# fix end of lines
perl -pi -e 'tr/\r//d;' \
    %{buildroot}%{_datadir}/doc/%{name}-doc-%{version}/www/index.htm \
    %{buildroot}%{_datadir}/doc/%{name}-doc-%{version}/www/www1/index.htm \
    %{buildroot}%{_datadir}/doc/%{name}-doc-%{version}/www/www3/index.htm

# fix configuration
rm -f %{buildroot}%{_prefix}/etc/*.in
sed -i -e '1,2d' %{buildroot}%{_sysconfdir}/*.conf

# move other examples under %{_docdir}
mv %{buildroot}%{_datadir}/mpich %{buildroot}%{_datadir}/doc/%{name}-doc-%{version}/examples

# Cleaning uncessary files 
rm -f %{buildroot}%{_libdir}/*.jar
rm -f %{buildroot}%{_libdir}/*.o
rm -rf %{buildroot}%{_prefix}/sbin
rm -rf %{buildroot}%{_datadir}/logfiles
rm -rf %{buildroot}%{_bindir}/clog*
rm -rf %{buildroot}%{_bindir}/slog*
rm -rf %{buildroot}%{_bindir}/jumpshot
rm -rf %{buildroot}%{_bindir}/logconvertor
rm -f %{buildroot}%{_bindir}/rlogTOslog2
rm -f %{buildroot}%{_bindir}/rlog_check_timeorder
rm -f %{buildroot}%{_bindir}/rlog_print
rm -f %{buildroot}%{_bindir}/rlogprint
rm -f %{buildroot}%{_bindir}/traceTOslog2.in
rm -f %{buildroot}%{_bindir}/traceprint.in
rm -f %{buildroot}%{_libdir}/libTraceInput.la

cat > README.urpmi <<EOF
Post-installation procedure:
- create a user with constant uid/gid and shared home directory on all nodes
- ensure this user has rsh/ssh access to all nodes
For instance, a solution could be:
	# groupadd -g 12384 -r -f mpi 
	# useradd -u 12384 -g mpi -d %{mpihome} -r -s /bin/bash mpi -p "" -m
	# mkpasswd -l 32 | passwd --stdin mpi 2>&1 > /dev/null
	# ssh-keygen -f %{mpihome}/.ssh/id_dsa -t dsa -N "" 2>&1 > /dev/null
	# chown mpi:mpi %{mpihome}/.ssh/id_dsa
	# chmod 600 %{mpihome}/.ssh/id_dsa
EOF

%clean
rm -rf %{buildroot}

%postun -n %{libname} -p /sbin/ldconfig

%post -n %{libname} -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc COPYRIGHT README.urpmi
%{_bindir}/mpd*
%{_bindir}/mpi*
%{_mandir}/man1/MPI.1*
%{_mandir}/man1/mpiexec.1.*
%config(noreplace) %{_sysconfdir}/mpe_*

%files -n %{libname}
%defattr(-,root,root)
%{_libdir}/*-%{major}.so

%files -n %{libname}-devel
%defattr(-,root,root)
%doc COPYRIGHT
%{_mandir}/man3/*.3*
%{_includedir}/*.h
%{_includedir}/*.mod
%{_libdir}/*.a
%{_libdir}/*.so
%exclude %{_libdir}/lib*-%{major}.so

%files doc
%defattr(-,root,root)
%{_datadir}/doc/%{name}-doc-%{version}

%files -n mpi2cc
%defattr(-,root,root)
%doc COPYRIGHT
%{_bindir}/mpicc
%config(noreplace) %{_sysconfdir}/mpicc.conf
%{_mandir}/man1/mpicc.1*

%files -n mpi2cxx
%defattr(-,root,root)
%doc COPYRIGHT
%{_bindir}/mpicxx
%config(noreplace) %{_sysconfdir}/mpicxx.conf
%{_mandir}/man1/mpicxx.1*

%files -n mpi2f77
%defattr(-,root,root)
%doc COPYRIGHT
%config(noreplace) %{_sysconfdir}/mpif77.conf
%{_bindir}/mpif77
%{_mandir}/man1/mpif77.1*

%files -n mpi2f90
%defattr(-,root,root)
%doc COPYRIGHT
%config(noreplace) %{_sysconfdir}/mpif90.conf
%{_bindir}/mpif90
%{_mandir}/man1/mpif90.1*


%changelog
* Thu Nov 16 2006 Guillaume Rousse <guillomovitch@mandriva.org> 1.0.4-7mdv2007.0
+ Revision: 84791
- new release
- really fix soname patch

* Tue Nov 14 2006 Guillaume Rousse <guillomovitch@mandriva.org> 1.0.4-6mdv2007.1
+ Revision: 84109
- rediff and fixed soname patch

* Fri Nov 10 2006 Guillaume Rousse <guillomovitch@mandriva.org> 1.0.4-5mdv2007.1
+ Revision: 80787
- bump release
- buildrequires python
- Import mpich2



* Wed Sep 06 2006 Erwan Velu <erwan@seanodes.com> 1.0.4-3mdv2007.0
- Buildrequires python (needed by mpdboot)

* Fri Aug 31 2006 Erwan Velu <erwan@seanodes.com> 1.0.4-2mdk
- The day before ulteo
- Fixing Conflicts with lam & mpich

* Mon Aug 21 2006 Erwan Velu <erwan@seanodes.com> 1.0.4-1mdk
- 1.0.4p1
- Removing patch0, merged upstream
- Removing chrpath buildrequires as cpi example is not provided under binary form
- Adding some stuff from ghuibo
- Setting f90 to gfortran

* Sun May 21 2006 Guillaume Rousse <guillomovitch@mandriva.org> 1.0.3-2mdk
- fix major in lib package name
- fix devel package provides

* Tue May 16 2006 Guillaume Rousse <guillomovitch@mandriva.org> 1.0.3-1mdk
- new version
- spec cleanup
- don't mess with /etc/bashrc, use profile.d
- use standard configure macro
- use -p for ldconfig invocation in %%post
- no more rsh requirement, as either rsh or ssh can be used
- no more user creation in %post, as it was too simplist to work, but advertise
  post-installation procedure through README.urpmi
- cleanup documentation
- no more useless shebang in configuration files
- fix summary
- fix group
- leverage versioned interdependencies
- drop useless explicit provides
- drop rpath in example
- add soname to libraries

* Sat Nov 26 2005 Thierry Vignaud <tvignaud@mandriva.com> 1.0.2-3mdk
- fix requires (#16327)

* Fri Jul 22 2005 Austin Acton <austin@mandriva.org> 1.0.2-2mdk
- fix library name
- make lib64 friendly

* Sun Jul 3 2005 Lev Givon <lev@columbia.edu> 1.0.2-1mdk
- upgrade to mpich2 1.0.2

* Mon Mar 21 2005 Antoine Ginies <aginies@n1.mandrakesoft.com> 1.0.1-2mdk
- add conflict with mpich-1.2.X
- rename mpic++ to mpi2cxx

* Fri Mar 18 2005 Antoine Ginies <aginies@n1.mandrakesoft.com> 1.0.1-1mdk
- release mpich2 1.0.1

* Fri Jul 27 2004 Erwan Velu <erwan@mandrakesoft.com> 1.2.5.2-5mdk
- Rebuild

* Fri Jun 25 2004 Erwan Velu <erwan@mandrakesoft.com> 1.2.5.2-4mdk
- Disabling java in jumpshot

* Tue Jun 15 2004 Erwan Velu <erwan@mandrakesoft.com> 1.2.5.2-3mdk
- Fixing requires

* Fri Jun 11 2004 Erwan Velu <erwan@mandrakesoft.com> 1.2.5.2-2mdk
- Fixing path for buildroot path removing
- Using a new test program
- Requires libmpich1 on mpich
* Sun Jan 04 2004 Per yvind Karlsen <peroyvind@linux-mandrake.com> 1.2.5.2-1mdk
- 1.2.5.2
- cosmetics
- don't rm -rf %{buildroot} at the beginning of %%prep
- no .bz2 ending for man pages in file list
- fix typo in Fortran interface for MPI_Wtime (P4)
- Fix to the MPI-IO Fortran interface (P5)
- work around rsh test that might stall (P6)
- fix unpackaged files
- fix permissions for docs

* Tue Jan 21 2003  <erwan@no.mandrakesoft.com> 1.2.5-1mdk
- New version

* Thu Jan 16 2003 Erwan Velu <erwan@mandrakesoft.com> 1.2.4-31mdk
- fixing missed wrong requires for gcc

* Thu Jan 16 2003 Erwan Velu <erwan@mandrakesoft.com> 1.2.4-30mdk
- Rebuild for new Glibc
- Changing gcc requires

* Thu Dec 05 2002 Clic-dev <clic-dev-public@mandrakesoft.com> 1.2.4-29mdk
- Fixing wrong source format (thx to Gtz Waschk)

* Thu Nov 21 2002 Clic-dev <clic-dev-public@mandrakesoft.com> 1.2.4-28mdk
- Adding missing files
- Changing default documentation paths

* Wed Nov 20 2002 Clic-dev <clic-dev-public@mandrakesoft.com> 1.2.4-27mdk
- Removing lam conflict

* Thu Oct 10 2002 Clic-dev <clic-dev-public@mandrakesoft.com> 1.2.4-26mdk
- Fixing f77 compilation problem (libmpichfarg)

* Thu Oct 10 2002 Clic-dev <clic-dev-public@mandrakesoft.com> 1.2.4-25mdk
- Switching back to ch_p4 because ch_p4mpd doesn't support SMP nodes
- Switching back traceback 

* Wed Oct 09 2002 Clic-dev <clic-dev-public@mandrakesoft.com> 1.2.4-24mdk
- Applying official cumulative patch (7073, 7090, 7096, 7201, 7187, 7265, 7276)

* Tue Oct 08 2002 Erwan Velu <erwan@mandrakesoft.com> 1.2.4-23mdk
- Enable traceback option
- Switching from ch_p4 to ch_p4mpd
- Fixing (again) libpmpich problems

* Mon Aug 26 2002 Erwan Velu <erwan@mandrakesoft.com> 1.2.4-22mdk
- Re-adding mpi user
- Applying officials mpich patches
- Fixing buildrequires
- Enable debug for TotalView
- Separting mpi and pmpi libs
- Using -soft tag (avoid install mpich to build mpich)

* Thu Aug 08 2002 Antoine Ginies <aginies@mandrakesoft.com> 1.2.4-21mdk
- correct requires (thx Goetz Waschk)
- remove mpi user

* Tue Aug 06 2002 Antoine Ginies <aginies@mandrakesoft.com> 1.2.4-20mdk
- build with gcc 3.2

* Wed Jul 10 2002 Erwan Velu <erwan@mandrakesoft.com> 1.2.4-19mdk
- Changing exports from /etc/profile to /etc/bashc

* Tue Jul 09 2002 Erwan Velu <erwan@mandrakesoft.com> 1.2.4-18mdk
- Changing gcc requires to 2.96

* Tue Jul 09 2002 Erwan Velu <erwan@mandrakesoft.com> 1.2.4-17mdk
- Fixing MPICH_INCLUDE_PROFLIB problem in mpicc,mpiCC,mpicxx, mpif90 and mpif77

* Sat Jul 06 2002 Erwan Velu <erwan@mandrakesoft.com> 1.2.4-16mdk
- Suse merge
- Removing libpmpi.so.*
- Spliting libs in sub packages

* Sat Jul 06 2002 Erwan Velu <erwan@mandrakesoft.com> 1.2.4-15mdk
- Adding pmpi lib !

* Sat Jul 06 2002 Erwan Velu <erwan@mandrakesoft.com> 1.2.4-14mdk
- Fixing specfile for building & installing lib*.so

* Thu Jul 04 2002 Erwan Velu <erwan@mandrakesoft.com> 1.2.4-13mdk
- Removing bashrc & bash profile
- Moving testmpi.mpich in docdir

* Tue Jun 25 2002 Antoine Ginies <aginies@mandrakesoft.com> 1.2.4-12mdk
- adjust environement variable in /etc/profile

* Mon Jun 17 2002 Erwan Velu <erwan@mandrakesoft.com> 1.2.4-11mdk
- Adding noreplace on configuration files
- Removing building hostname on machines.LINUX

* Thu Jun 06 2002 Erwan Velu <erwan@mandrakesoft.com> 1.2.4-10mdk
- Setting mpi user id
* Wed Jun 05 2002 Erwan Velu <erwan@mandrakesoft.com> 1.2.4-9mdk
- Fixing typo in .bashrc of mpi user

* Tue Jun 04 2002 Erwan Velu <erwan@mandrakesoft.com> 1.2.4-8mdk
- Fixing wrong perm on sample script
- Using another sample script program

* Tue Jun 04 2002 Erwan Velu <erwan@mandrakesoft.com> 1.2.4-7mdk
- Removing gcc require on main mpich package
- Removing virtual Mpi provide

* Mon Jun 03 2002 Erwan Velu <erwan@mandrakesoft.com> 1.2.4-6mdk
- Fixing stupid friday mistake

* Fri May 31 2002 Erwan Velu <erwan@mandrakesoft.com> 1.2.4-5mdk
- Adding hello world sample mpi test program
- Adding ch_p4 option 

* Thu May 30 2002 Erwan Velu <erwan@mandrakesoft.com> 1.2.4-4mdk
- Adding /usr/adm for serv_p4 process
- Adding MPIRUN_HOME in default environment of mpi user

* Tue May 28 2002 Erwan Velu <erwan@mandrakesoft.com> 1.2.4-3mdk
- Adding more conflicts with lam

* Fri May 24 2002 Erwan Velu <erwan@mandrakesoft.com> 1.2.4-2mdk
- Provides virtual Mpi
- Fixing spec file

* Wed May 22 2002 Erwan Velu <erwan@mandrakesoft.com> 1.2.4-1mdk
- New release
- Bug-fix and improved-SMP performance release
- Other new features include better support for Intel compilers, particularly for IA64 Linux,
better support for various Fortran compilers, and some fixes for rare race conditions in the ch_p4 device.

* Wed May 22 2002 Erwan Velu <erwan@mandrakesoft.com> 1.2.2.2-7mdk
- Fixing home dir for MPI user
- Gcc 3.1 build

* Tue Apr 23 2002 Erwan Velu <erwan@mandrakesoft.com> 1.2.2.2-6mdk
- Fixing stupid places of man pages
- Fixing forgoten dependencies
- Adding rhosts example and warnings
- Adding MPI user

* Fri Apr 12 2002 Erwan Velu <erwan@mandrakesoft.com> 1.2.2.2-5mdk
- Fixing stupid things

* Fri Nov 23 2001 Ludovic Francois <lfrancois@mandrakesoft.com> 1.2.2.2-4mdk
- Removed unresolved dependencies

* Mon Nov 19 2001 Ludovic Francois <lfrancois@mandrakesoft.com> 1.2.2.2-3mdk
- Added sub packages mpich-doc mpicc mpic++ mpif77

* Tue Oct 25 2001 Ludovic Francois <lfrancois@mandrakesoft.com> 1.2.2.2-2mdk
- Rebuild for rpmlint

* Fri Oct 12 2001 Ludovic Francois <lfrancois@mandrakesoft.com> 1.2.2.2-1mdk
- Mpich package build for the first time.
